﻿using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Identity;
using Props.Models.Search;
using Props.Shared.Models.User;

namespace Props.Models.User
{
    public class ApplicationUser : IdentityUser
    {
        public virtual ISet<SearchOutline> SearchOutlines { get; set; }

        [Required]
        public virtual ResultsPreferences ResultsPreferences { get; private set; }

        [Required]
        public virtual ApplicationPreferences ApplicationPreferences { get; private set; }

        // TODO: Write project system.
        public ApplicationUser()
        {
            ResultsPreferences = new ResultsPreferences();
            ApplicationPreferences = new ApplicationPreferences();
        }

        public ApplicationUser(ResultsPreferences resultsPreferences, ApplicationPreferences applicationPreferences)
        {
            this.ResultsPreferences = resultsPreferences;
            this.ApplicationPreferences = applicationPreferences;
        }
    }
}
